abuild.in 24.6 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
apkcache=@apkcache@
Natanael Copa's avatar
Natanael Copa committed
14 15 16

startdir="$PWD"
srcdir=${srcdir:-"$startdir/src"}
17
pkgbasedir=${pkgbasedir:-"$startdir/pkg"}
Natanael Copa's avatar
Natanael Copa committed
18
pkgrel=0
Natanael Copa's avatar
Natanael Copa committed
19 20
repo=${startdir%/*}
repo=${repo##*/}
Natanael Copa's avatar
Natanael Copa committed
21 22 23 24

# defaults
SRCDEST=${SRCDEST:-$startdir}
PKGDEST=${PKGDEST:-$startdir}
25
BUILD_BASE="build-base"
Natanael Copa's avatar
Natanael Copa committed
26

27 28
SUDO=${SUDO:-"sudo"}

29
default_cmds="sanitycheck builddeps clean fetch unpack rootpkg apkcache"
Natanael Copa's avatar
Natanael Copa committed
30

Natanael Copa's avatar
Natanael Copa committed
31
# read config
Natanael Copa's avatar
Natanael Copa committed
32
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
33 34
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

Natanael Copa's avatar
Natanael Copa committed
35
# source functions
36 37
datadir=/usr/share/abuild

Natanael Copa's avatar
Natanael Copa committed
38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69
#colors
if [ -n "$USE_COLORS" ]; then
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
fi	
	

# functions
msg() {
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	[ -z "$quiet" ] && printf "${prompt} ${name}${fake}: $@\n" >&2
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}
Natanael Copa's avatar
Natanael Copa committed
70 71

	
Linux User's avatar
Linux User committed
72 73
set_xterm_title() {
	if [ "$TERM" = xterm ]; then
74
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
75 76 77 78 79
	fi
} 

cleanup() {
	set_xterm_title ""
80
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
81
		$SUDO apk del $uninstall_after
82
	fi
Linux User's avatar
Linux User committed
83 84
}

Natanael Copa's avatar
Natanael Copa committed
85
die() {
Linux User's avatar
Linux User committed
86
	error "$@"
Linux User's avatar
Linux User committed
87
	cleanup
Natanael Copa's avatar
Natanael Copa committed
88 89 90
	exit 1
}

91 92
# check if apkbuild is basicly sane
sanitycheck() {
Natanael Copa's avatar
Natanael Copa committed
93
	local i
94
	msg "Checking sanity of $APKBUILD..."
95 96 97
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
98 99
	apk version --check -q "$pkgver" ||\
		die "$pkgver is not a valid version"
100 101 102 103 104
	[ -z "$pkgrel" ] && warning "Missing pkgrel in APKBUILD. Using pkgrel=0"
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

Natanael Copa's avatar
Natanael Copa committed
105 106 107 108 109 110 111
	for i in $install; do
		[ -e "$startdir/$i" ] || die "install script $startdir/$i is missing"
	done
	
	[ -n "${triggers%%:*}" ] && [ ! -e "$startdir"/${triggers%%:*} ] \
		&& die "trigger script $startdir/${triggers%%:*} is missing"

112 113
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
114 115 116 117
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
118
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
Natanael Copa's avatar
Natanael Copa committed
119 120 121
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
122 123
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
124

125 126
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
Natanael Copa's avatar
Natanael Copa committed
127
			source_has $i || die "$i exists in md5sums but is missing in source"
128 129
		done
	fi
130

131 132 133
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
134 135

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
136 137

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
138 139 140 141
	return 0
}

md5check() {
Natanael Copa's avatar
Natanael Copa committed
142
	local dummy f
143 144 145
	if [ -z "$source" ]; then
		return 0
	fi
146
	if [ -z "$md5sums" ]; then
147
		die "Use 'abuild checksum' to generate/update the checksum(s)"
148
	fi
149 150 151
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
152
	fetch || return 1
153
	msg "Checking md5sums..."
154
	cd "$srcdir" && echo "$md5sums" | md5sum -c 
Natanael Copa's avatar
Natanael Copa committed
155 156 157 158 159
}

uri_fetch() {
	local uri="$1"
	local d="${s##*/}"	# $(basename $s)
160 161 162 163
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

Natanael Copa's avatar
Natanael Copa committed
164 165 166 167 168 169
	
	# we need GNU wget for this
	case "$uri" in
		https://*) opts="--no-check-certificate";;
	esac
	
Natanael Copa's avatar
Natanael Copa committed
170
	mkdir -p "$SRCDEST"
171 172 173
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
174
	fi
Linux User's avatar
Linux User committed
175
	msg "Fetching $uri"
176 177
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
178 179
}

180 181
is_remote() {
	case "$1" in
Natanael Copa's avatar
Natanael Copa committed
182
		http://*|ftp://*|https://*)
183 184 185 186 187
			return 0;;
	esac
	return 1
}

Natanael Copa's avatar
Natanael Copa committed
188 189 190
fetch() {
	local s
	mkdir -p "$srcdir"
191 192 193 194 195 196 197
	for s in $source; do
		if is_remote "$s"; then
			uri_fetch "$s" || return 1
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
198 199 200 201 202 203
	done
}

# unpack the sources
unpack() {
	local u
204
	md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
205 206 207 208
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
209
			*.tar.gz|*.tgz)
210
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
211 212
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
213
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
214
				tar -C "$srcdir" -jxf "$s" || return 1;;
215 216 217 218
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
Natanael Copa's avatar
Natanael Copa committed
219 220 221
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
222 223 224 225 226 227
		esac
	done
}

# cleanup source and package dir
clean() {
228
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
229
	rm -rf "$srcdir"
230
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
231 232 233 234 235 236
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
237 238 239 240
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
241 242 243 244 245
	done
}

cleanpkg() {
	local i
246
	msg "Cleaning built packages..."
247
	for i in $pkgname $subpackages; do
248 249
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
250
			"$apkcache"/$p.apk
Natanael Copa's avatar
Natanael Copa committed
251
	done
252
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
253 254
}

255 256 257 258 259 260 261 262 263 264 265 266 267
# clean all packages except current
cleanoldpkg() {
	local i j
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
	for i in $pkgname $subpackages; do
		for j in "$PKGDEST"/${i%:*}-[0-9]*.apk; do
			[ "$j" != "$PKGDEST/${i%:*}-$pkgver-r$pkgrel.apk" ] \
				&& rm -f "$j"
		done
	done
	return 0
}
	
Natanael Copa's avatar
Natanael Copa committed
268 269
runpart() {
	local part=$1
270
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
271 272 273 274 275 276 277 278
	$part || die "$part failed"
}

# override those in your build script
build() {
	die "No build() function found in $APKBUILD"
}

Natanael Copa's avatar
Natanael Copa committed
279 280 281 282 283 284 285 286 287
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

288
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
289
	if [ -z "$subpackages" ]; then
290 291
		return 0
	fi
Natanael Copa's avatar
Natanael Copa committed
292 293
	local i
	cd "$startdir"
294
	for i in $subpackages; do
Natanael Copa's avatar
Natanael Copa committed
295 296
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
297
		msg "Running split function $func..."
298
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
299
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
300 301 302
	done
}

303
prepare_metafiles() {
304 305
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
306
	local dir=${subpkgdir:-$pkgdir}
307
	local pkg="$name-$pkgver-r$pkgrel.apk"
308
	local pkginfo="$controldir"/.PKGINFO
309
	local sub
Natanael Copa's avatar
Natanael Copa committed
310 311 312
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
313
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
314 315 316
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')

317
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
318
	if [ -n "$FAKEROOTKEY" ]; then
319
		echo "# using $(fakeroot -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
320
	fi
321 322
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
323
pkgname = $name
324
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
325 326 327 328 329 330
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
EOF
331 332
	local i deps
	deps="$depends"
333
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
Natanael Copa's avatar
Natanael Copa committed
334 335
		for i in $install ${triggers%%:*}; do
			if head -n 1 "$startdir/$i" | grep '^#!/bin/sh' >/dev/null ; then
336 337 338 339 340
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
341 342
	fi
	
Natanael Copa's avatar
Natanael Copa committed
343
	for i in $license; do
344
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
345 346
	done
	for i in $replaces; do
347
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
348
	done
349
	for i in $deps; do
350
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
351 352
	done
	for i in $conflicts; do
353
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
354 355
	done
	for i in $provides; do
356
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
357 358
	done
	for i in $backup; do
359
		echo "backup = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
360
	done
Natanael Copa's avatar
Natanael Copa committed
361 362 363
	if [ -n "$triggers" ]; then
		echo "triggers = ${triggers#*:}" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
364 365

	local metafiles=".PKGINFO"
Natanael Copa's avatar
Natanael Copa committed
366
	for i in $install ${triggers%%:*}; do
367 368
		script=${i#$name}
		case "$script" in
Natanael Copa's avatar
Natanael Copa committed
369
			.pre-install|.post-install|.pre-upgrade|.post-upgrade|.pre-deinstall|.post-deinstall|.trigger)
370 371
				msg "Adding $script"
				;;
Natanael Copa's avatar
Natanael Copa committed
372
			*) 	error "$script: Invalid install/trigger script"
373 374 375
				return 1
				;;
		esac
Natanael Copa's avatar
Natanael Copa committed
376
		cp "$startdir/$i" "$controldir/$script" || return 1
377
		chmod +x "$controldir/$script"
378 379
		metafiles="$metafiles $script"
	done
380
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
381
}
382

383 384 385
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
	options_has "!tracedeps" && return 0
386 387
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
388
	scanelf -Rn "$dir" | awk -F "\ " '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
389 390 391
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
392 393
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
394
	done
Natanael Copa's avatar
Natanael Copa committed
395 396
}

397
prepare_package() {
398
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
399
	stripbin
400
	prepare_metafiles
401
	prepare_tracedeps
402 403 404 405 406 407 408 409
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

410 411 412
trace_apk_deps() {
	local name="$1"
	local dir="$2"
413 414
	local i j found autodeps=
	msg "Tracing dependencies for $name..."
415
	for i in $(cat "$dir"/.needs-so 2>/dev/null); do
416
		found=
417
		# first check if its provide by same apkbuild
418
		for j in "$dir"/../.control.*/.provides-so; do
419
			grep -w "$i" "$j" >/dev/null || continue
420
			found=${j%/.provides-so}
421
			found=${found##*/.control.}
422
			break
423 424 425 426 427 428 429 430 431
		done
		# check apk db if not provided by a subpackage
		if [ -z "$found" ]; then
			found=$(apk info -q -W /lib/$i /usr/lib/$i)
		fi
		if [ -z "$found" ]; then
			error "Could not find dependency for $i"
			return 1
		fi
432
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
433 434 435
			warning "You can remove '$found' from depends"
			continue
		fi
436 437
		list_has "$found" $autodeps || autodeps="$autodeps $found"
		msg "Added '$found' as dependency as it has $i"
438 439 440 441 442 443
	done
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
444 445 446 447 448 449
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasdir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
		msg "Added pkgconfig as dependency"
		echo "depend = pkgconfig" >> "$dir"/.PKGINFO
	fi
450 451
}

452 453
create_apks() {
	local file
454
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
455 456 457
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
458
		local apk=$name-$ver.apk
459
		local datadir="$pkgbasedir"/$name
460 461

		trace_apk_deps "$name" "$dir" || return 1
462
		msg "Creating $apk..."
463
		(
464 465
		cd "$datadir"
		# data.tar.gz
466 467 468 469 470 471
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
472 473 474 475 476 477

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
478
		cd "$dir"
479 480
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
481
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
482

483 484 485
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
486 487 488
	done
}

489
apkcache() {
490
	if ! apk_up2date || [ -n "$force" ]; then
491 492
		sanitycheck && builddeps && clean && fetch && unpack && rootpkg || return 1
	fi
493

494
	local apk
495
	mkdir -p "$apkcache" || return 1
496 497 498 499 500 501 502 503 504 505
	cd "$apkcache"

	# remove broken links
	for apk in *.apk; do
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done

	# create links for this package
506
	for apk in $(listpkg); do
507
		ln -sf "$PKGDEST"/$apk "$apkcache"/$apk
508 509
	done

510
	msg "Updating the cached abuild repository index..."
511 512 513 514 515 516 517 518 519
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
	if [ -f APKINDEX.tar.gz ]; then
		oldindex="--index APKINDEX.tar.gz"
	fi
	apk index $oldindex --output APKINDEX.tar.gz.unsigned *.apk || exit 1
	msg "Signing the index..."
	abuild-sign -q APKINDEX.tar.gz.unsigned || exit 1
	mv APKINDEX.tar.gz.unsigned APKINDEX.tar.gz
Natanael Copa's avatar
Natanael Copa committed
520
	chmod 644 APKINDEX.tar.gz
521 522
}

523
# predefined splitfunc doc
524
default_doc() {
525
	depends="$depends_doc"
526
	install="$install_doc"
Natanael Copa's avatar
Natanael Copa committed
527
	triggers="$triggers_doc"
Natanael Copa's avatar
Natanael Copa committed
528
	local i
529
	for i in doc man info html sgml licenses gtk-doc; do
530 531 532
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
533 534
		fi
	done
535 536 537
	
	rm -f "$subpkgdir/usr/share/info/dir"

538 539 540
#	# compress info and man pages
#	find "$subpkgdir/usr/share" \( -name '*.info' -o -name '*.info-[1-9]' \
#		-o -name '*.[1-9]' \) -exec gzip {} \;
541 542 543 544

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
545
#	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
546 547 548
	return 0
}

549 550 551 552
doc() {
	default_doc
}

553
# predefined splitfunc mod
554
default_mod() {
555
	depends="$kernel $depends_mod"
556
	install="$install_mod"
Natanael Copa's avatar
Natanael Copa committed
557
	for i in firmware modules; do
558 559 560
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
561
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
562 563 564 565
		fi
	done
}

566 567 568 569
mod() {
	default_mod
}

570
# predefined splitfunc dev
571
default_dev() {
572
	local i
573
	depends="$pkgname $depends_dev"
574
	install="$install_dev"
Natanael Copa's avatar
Natanael Copa committed
575
	triggers="$triggers_dev"
576 577 578 579
	for i in $origsubpackages; do
		[ "${i%:*}" = "$subpkgname" ] || depends="$depends ${i%:*}"
	done
		
580
	cd "$pkgdir" || return 0
581 582 583 584 585
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
			$(find -name include -type d) 		\
			$(find usr/ -name '*.[acho]' -o -name '*.la' \
			2>/dev/null); do
586 587
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
588
			mkdir -p "$d"
589
			mv "$pkgdir/$i" "$d"
590
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
591 592
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
593
	return 0
Natanael Copa's avatar
Natanael Copa committed
594 595
}

596 597 598 599
dev() {
	default_dev
}

Natanael Copa's avatar
Natanael Copa committed
600 601
# build and package in fakeroot
rootpkg() {
Natanael Copa's avatar
Natanael Copa committed
602
	cd "$startdir"
603
	msg "Entering fakeroot..."
604
	fakeroot $0 build prepare_subpackages prepare_package create_apks
Natanael Copa's avatar
Natanael Copa committed
605 606 607
}

srcpkg() {
608
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
609
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
610 611 612 613 614
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
615
	msg "Creating source package $p.src.tar.gz..."
616
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
617 618
}

619
# check if package is up to date
620
apk_up2date() {
621
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
622
	local i s
Natanael Copa's avatar
Natanael Copa committed
623
	cd "$startdir"
624 625 626 627 628
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

629
	for i in $source APKBUILD; do
630 631 632 633 634 635
		local s
		if is_remote "$i"; then
			s="$SRCDEST/${i##*/}"	# $(basename $i)
		else
			s="$startdir/${i##*/}"
		fi
636 637 638 639 640 641 642
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

643 644 645 646
cache_up2date() {
	local i apk
	for i in $pkgname $subpackages; do
		apk="${i%:*}-$pkgver-r$pkgrel.apk"
647
		[ "$apkcache"/APKINDEX.tar.gz -nt "$apkcache"/$apk ] || return 1
648 649 650 651 652 653 654 655
	done
	return 0
}

up2date() {
	apk_up2date && cache_up2date
}

656 657 658 659 660 661 662 663 664 665 666 667 668
# source all APKBUILDs and output:
#  1) origin of package
#  2) all dependencies
# the output is i in a format easy parseable for awk
depparse_aports() {
	# lets run this in a subshell since we source all APKBUILD here
	(
	aportsdir=$(realpath ${APKBUILD%/APKBUILD}/../..)
	for i in $aportsdir/*/*/APKBUILD; do
		pkgname=
		subpackages=
		depends=
		makedepends=
669
		. $i
670
		dir=${i%/APKBUILD}
671
		deps=
672
		# filter out conflicts from deps and version info
673 674 675 676
		for j in $depends $makedepends; do
			case "$j" in
				!*) continue;;
			esac
677
			deps="$deps ${j%[<>=]*}"
678
		done
679
		for j in $pkgname $subpackages; do
680
			echo "o ${j%%:*} $dir"
681
			set -- $deps
682 683 684 685 686 687 688
			echo -n "d ${j%%:*} $1"
			shift
			while [ $# -gt 0 ]; do
				echo -n ",$1"
				shift
			done
			echo
689 690
		done
	done
691
	)
692 693
}

694
deptrace() {
695
	local deps="$@"
696
	[ -z "$deps" ] && return 0
697 698 699
	( 	depparse_aports 
		if [ -z "$upgrade" ]; then
			# list installed pkgs and prefix with 'i '
Natanael Copa's avatar
abuild:  
Natanael Copa committed
700
			apk info -q | sort |  sed 's/^/i /'
701
		fi
702
	) | awk -v pkgs="$deps" '
703 704 705 706 707 708 709 710 711 712 713 714 715 716 717 718 719 720 721 722 723 724 725 726 727

	function depgraph(pkg,	a, i) {
		if (visited[pkg])
			return 0;
		visited[pkg] = 1;
		split(deps[pkg], a, ",");
		for (i in a)
			depgraph(a[i]);
		print pkg ":" origin[pkg];

	}

	$1 == "i" { visited[$2] = 1 }
	$1 == "o" { origin[$2] = $3 }
	$1 == "d" { deps[$2] = $3 }
	END {
		split(pkgs, pkgarray);
		for (i in pkgarray)
			depgraph(pkgarray[i]);
	}
	'
}

# build and install dependencies
builddeps() {
728 729
	local deps= alldeps= pkg= i= dir= ver= missing= installed_deps=
	local filtered_deps=
730
	[ -n "$nodeps" ] && return 0
731
	msg "Analyzing dependencies..."
732 733 734 735
	deps="$BUILD_BASE $makedepends"

	# add depends unless it is a subpackage
	for i in $depends; do
736
		subpackages_has ${i%[<>=]*} || deps="$deps $i"
737 738
	done

739
	installed_deps=$(apk info -e $deps)
740
	# find which deps are missing
741
	for i in $deps; do
742
		if [ "${i#\!}" != "$i" ]; then
743
			list_has ${i#\!} $installed_deps \
744
				&& die "Conflicting package ${i#\!} is installed."
745
		elif ! deplist_has $i $installed_deps; then
746 747 748 749 750 751 752
			if [ -z "$install_deps" ] && [ -z "$recursive" ]; then
				die "Missing dependency $i. Use -r to autoinstall or -R to build"
			fi
			missing="$missing $i"
		fi
	done

753 754
	[ -z "$missing" ] && [ -z "$install_deps" ] && [ -z "$recursive" ] \
		&& return 0
755

756
	uninstall_after=".makedepends-$pkgname $uninstall_after"
757
	if [ -n "$install_deps" ] && [ -z "$recursive" ]; then
758
		$SUDO apk add --repository "$apkcache" \
759 760
			--virtual .makedepends-$pkgname $deps \
			&& return 0
761
	fi
762 763
	
	[ -z "$recursive" ] && return 1
764 765 766

	# find dependencies that are installed but missing in repo.
	for i in $deps; do
767
		local m=$(apk search --repository "$apkcache" ${i%[<>=]*})
Natanael Copa's avatar
Natanael Copa committed
768
		if [ -z "$m" ]; then
769 770 771
			missing="$missing $i"
		fi
	done
772 773
	
	for i in $(deptrace $missing); do
774 775 776 777
		# i = pkg:dir
		local dir=${i#*:}
		local pkg=${i%:*}
		msg "Entering $dir"
778
		cd "$dir" && $0 -k -r apkcache || return 1
779
	done
780
	$SUDO apk add -u --repository "$apkcache" \
781
		--virtual .makedepends-$pkgname $deps
782 783
}

784
# replace the md5sums in the APKBUILD
Natanael Copa's avatar
Natanael Copa committed
785 786
checksum() {
	local s files
787
	[ -z "$source" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
788
	fetch
789
	msg "Updating the md5sums in APKBUILD..."
Natanael Copa's avatar
Natanael Copa committed
790 791 792 793
	for s in $source; do
		files="$files ${s##*/}"
	done
	md5sums="$(cd "$srcdir" && md5sum $files)" || die "md5sum failed"
794 795
	sed -i -e '/^md5sums="/,/"\$/d; /^md5sums=''/,/''\$/d' "$APKBUILD"
	echo "md5sums=\"$md5sums\"" >>"$APKBUILD"
Natanael Copa's avatar
Natanael Copa committed
796 797
}

798
stripbin() {
799
	local bin
800
	options_has "!strip" && return 0
801 802
	cd "${subpkgdir:-$pkgdir}" || return 1
	msg "Stripping binaries"
803
	find . -type f 2>/dev/null | while read bin; do
804 805 806 807 808 809 810 811 812 813 814
		local opt=
		case "$(file -biz "$bin")" in
			*/x-sharedlib*|*/x-archive*)
				strip --strip-debug "$bin";;
			*/x-executable*)
				strip "$bin";;
		esac
	done
	return 0
}

815 816 817 818 819 820 821 822
# simply list target apks
listpkg() {
	local i 
	for i in $pkgname $subpackages; do
		echo "${i%:*}-$pkgver-r$pkgrel.apk"
	done
}

Natanael Copa's avatar
Natanael Copa committed
823 824 825 826 827 828 829 830
source_has() {
	local i
	for i in $source; do
		[ "$1" = "${i##*/}" ] && return 0
	done
	return 1
}

Natanael Copa's avatar
abuild:  
Natanael Copa committed
831 832 833 834 835 836 837 838
subpackages_has() {
	local i
	for i in $subpackages; do
		[ "$1" = "${i%:*}" ] && return 0
	done
	return 1
}

839 840 841 842 843 844 845 846 847 848 849
list_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

850 851 852 853 854 855 856 857 858 859 860 861 862
# same as list_has but we filter version info
deplist_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
		i=${i%[<>=]*}
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

863 864 865 866
options_has() {
	list_has "$1" $options
}

867
depends_has() {
868
	deplist_has "$1" $depends
869 870
}

Natanael Copa's avatar
Natanael Copa committed
871
makedepends_has() {
872
	deplist_has "$1" $makedepends
Natanael Copa's avatar
Natanael Copa committed
873 874
}

Natanael Copa's avatar
Natanael Copa committed
875 876 877 878
md5sums_has() {
	list_has "$1" $md5sums
}

Natanael Copa's avatar
Natanael Copa committed
879 880 881 882
install_has() {
	list_has "$1" $install
}

Natanael Copa's avatar
abuild:  
Natanael Copa committed
883 884 885 886 887 888 889 890 891 892 893 894 895 896
# install package after build
post_add() {
	local pkgf="$PKGDEST/$1-$pkgver-r$pkgrel.apk"
	local deps i
	if ! subpackages_has $1 && [ "$1" != "$pkgname" ]; then
		die "$1 is not built by this APKBUILD"
	fi
	# recursively install dependencies that are provided by this APKBUILD
	deps=$(apk index "$pkgf" 2>/dev/null | awk -F: '$1=="D" { print $2 }')
	for i in $deps; do
		if subpackages_has $i || [ "$i" = "$pkgname" ]; then
			post_add $i || return 1
		fi
	done
897
	$SUDO apk add -u "$pkgf" || die "Failed to install $1"
Natanael Copa's avatar
abuild:  
Natanael Copa committed
898 899
}

900 901 902 903 904 905 906 907 908 909 910 911 912 913 914 915 916 917 918 919 920 921 922
# create new aport from templates
newaport() {
	local pn=${newname%-[0-9]*}
	local pv
	if [ "$pn" != "$newname" ]; then
		pv=${newname#$pn-}
	fi
	if [ -e "$pn"/APKBUILD ]; then
		error "$pn/APKBUILD already exist"
		return 1
	fi
	mkdir -p "$pn"
	cd "$pn"
	sed 	-e '1,/^\#*$/d' \
		-e "s/^\(# Contributor: \).*/\1$PACKAGER/" \
		-e "s/^\(# Maintainer: \).*/\1$PACKAGER/" \
		-e "s/^pkgname=.*/pkgname=$pn/" \
		-e "s/^pkgver=.*/pkgver=$pv/" \
		"$datadir"/sample.APKBUILD > APKBUILD || return 1
	#-e '1,/^\#$/d' \
	if [ -n "$cpinitd" ]; then
		cp "$datadir"/sample.initd $pn.initd
		cp "$datadir"/sample.confd $pn.confd
923 924 925
		cp "$datadir"/sample.pre-install $pn.pre-install
		cp "$datadir"/sample.post-install $pn.post-install
		sed -i -e "s/^install=.*/install=\"\$pkgname.pre-install \$pkgname.post-install\"/" \
926 927 928 929 930
			-e "s/^source=\"\(.*\)\"/source=\"\1\n\t$pn.initd\n\t$pn.confd\n\t\$install\n\t\"/" \
			APKBUILD
		
	fi
}
931 932

installdeps() {
933
	local deps i
934
	sudo apk add --repository "$apkcache" --virtual .makedepends-$pkgname \
935
		$makedepends
936 937 938
}

uninstalldeps (){
939
	sudo apk del .makedepends-$pkgname
940
}
941 942 943 944 945 946 947 948 949

all() {
	if up2date && [ -z "$force" ]; then
		msg "Package is up to date"
	else
		apkcache
	fi
}

Natanael Copa's avatar
Natanael Copa committed
950
usage() {
951
	echo "$(basename $0) $abuild_ver"
952 953
	echo "usage: ${0##*/} [options] [-i PKG] [-P REPODEST] [-p PKGDEST]"
	echo "              [-s SRCDEST] [cmd] ..."
954
	echo "       ${0##*/} [-c] -n PKGNAME[-PKGVER]"
Natanael Copa's avatar
Natanael Copa committed
955
	echo "Options:"
956
	echo " -d  Disable dependency checking"
Natanael Copa's avatar
Natanael Copa committed
957
	echo " -f  Force specified cmd, even if they are already done"
958 959
	echo " -h  Show this help"
	echo " -i  Install PKG after successul build"
960
	echo " -k  Keep built packages, even if APKBUILD or sources are newer"
961
	echo " -p  Set package destination directory"
962
	echo " -P  Set PKGDEST to REPODEST/<repo>, where repo is the parents dir name" 
Natanael Copa's avatar
Natanael Copa committed
963
	echo " -q  Quiet"
964 965
	echo " -r  Install missing dependencies from system repository (using sudo)"
	echo " -R  Recursively build and install missing dependencies (using sudo)"
966
	echo " -s  Set source package destination directory"
967
	echo " -u  Recursively build and upgrade all dependencies (using sudo)"
Natanael Copa's avatar
Natanael Copa committed
968
	echo ""
969 970 971
	echo " -n  Create a new APKBUILD in a directory named PKGNAME"
	echo " -c  Copy a sample init.d, conf.d and install script to new directory"
	echo ""
Natanael Copa's avatar
Natanael Copa committed
972
	echo "Commands:"
973
	echo "  checksum    Generate checksum to be included in APKBUILD"
974 975 976 977 978
	echo "  fetch       Fetch sources to \$SRCDEST and verify checksums"
	echo "  sanitycheck Basic sanity check of APKBUILD"
	echo "  md5check    Check md5sums"
	echo "  unpack      Unpack sources to \$srcdir"
	echo "  build       Compile and install package into \$pkgdir"
979
	echo "  listpkg     List target packages"
980 981 982
	echo "  package     Create package in \$PKGDEST"
	echo "  rootpkg     Run '$0 build package' as fakeroot"
	echo "  clean       Remove temp build and install dirs"
983
	echo "  cleanoldpkg Remove binary packages except current version"
984 985 986 987
	echo "  cleanpkg    Remove already built binary and source package"
	echo "  cleancache  Remove downloaded files from \$SRCDEST"
	echo "  srcpkg      Make a source package"
	echo "  up2date     Compare target and sources dates"
988 989
	echo "  installdeps Install packages listed in makedepends and depends"
	echo "  uninstalldeps Uninstall packages listed in makedepends and depends"
Natanael Copa's avatar
Natanael Copa committed
990 991 992 993 994
	echo ""
	exit 0
}

APKBUILD="${APKBUILD:-./APKBUILD}"
995 996
unset force
unset recursive
997
while getopts "cdfhi:kin:p:P:qrRs:u" opt; do
Natanael Copa's avatar
Natanael Copa committed
998
	case $opt in
999
		'c') cpinitd=1;;
1000
		'd') nodeps=1;;
Natanael Copa's avatar
Natanael Copa committed
1001
		'f') force=1;;
1002 1003
		'h') usage;;
		'i') install_after="$install_after $OPTARG";;
1004
		'k') keep=1;;
1005
		'n') newname=$OPTARG;;
1006
		'p') PKGDEST=$OPTARG;;
1007
		'P') REPODEST=$OPTARG;;
Natanael Copa's avatar
Natanael Copa committed
1008
		'q') quiet=1;;
1009 1010
		'r') install_deps=1;;
		'R') recursive=1;;
1011
		's') SRCDEST=$OPTARG;;
1012 1013
		'u') upgrade=1
		     recursive=1;;
Natanael Copa's avatar
Natanael Copa committed
1014 1015 1016 1017
	esac
done
shift $(( $OPTIND - 1 ))

1018 1019 1020 1021 1022
# If REPODEST is set then it will override the PKGDEST
if [ -n "$REPODEST" ]; then
	PKGDEST="$REPODEST/$repo"
fi

1023
# source the buildfile
1024 1025 1026 1027
if [ -z "$newname" ]; then
	[ -f "$APKBUILD" ] || die "Could not find $APKBUILD (PWD=$PWD)"
	. "$APKBUILD"
fi
1028

1029
# If we are handling a sub package then reset subpackages and install
1030
if [ -n "$subpkgname" ]; then
1031
	origsubpackages="$subpackages"
1032
	subpackages=
1033
	install=
1034
fi
1035
pkgdir="$pkgbasedir/$pkgname"
1036
controldir="$pkgbasedir"/.control.${subpkgname:-$pkgname}
Natanael Copa's avatar
Natanael Copa committed
1037 1038

trap 'die "Aborted by user"' INT
Linux User's avatar
Linux User committed
1039
set_xterm_title "abuild: $pkgname"
Natanael Copa's avatar
Natanael Copa committed
1040

1041 1042 1043
if [ -z "$1" ] && [ -n "$newname" ]; then
	set "newaport"
fi
Natanael Copa's avatar
Natanael Copa committed
1044 1045

if [ -z "$1" ]; then
1046
	set all
Natanael Copa's avatar
Natanael Copa committed
1047 1048 1049 1050 1051 1052
fi

while [ $# -gt 0 ]; do
	runpart $1
	shift
done
1053 1054

for i in $install_after; do
Natanael Copa's avatar
abuild:  
Natanael Copa committed
1055
	post_add $i
1056 1057
done

Linux User's avatar
Linux User committed
1058
cleanup
Natanael Copa's avatar
Natanael Copa committed
1059